local L = AceLibrary("AceLocale-2.2"):new("NinjutFu")
local tablet = AceLibrary("Tablet-2.0")
local crayon = AceLibrary("Crayon-2.0")

function NinjutFu:OnTooltipUpdate()
	local cat = tablet:AddCategory(
		'columns', 2,
		'child_textR', 1,
		'child_textG', 1,
		'child_textB', 1,
		'child_textR2', 1,
		'child_textG2', 1,
		'child_textB2', 1
	)
	
	local p = self.db.profile
	local itemCounts = self.itemCounts
	for category in self:IterItemCategories() do
		local first = true
		if string.find(p.tooltipSkipCategories, category .. ":") == nil then
			for itemid in self:IterCategoryItems(category) do
				if itemCounts[itemid] and itemCounts[itemid] ~= 0 then
					if first and p.showTipTitles then
						cat:AddLine('text', crayon:Green(L[category]))
						first = false
					end
					cat:AddLine('text', GetItemInfo(itemid), 'text2', self:Colorize(itemCounts[itemid], (itemid == 5140) and p.threshCount or (itemid == 7676 and 10 or 20)))
				end
			end
			if not first then
				cat:AddLine()
			end
		end
	end
	tablet:SetHint(L["Hint"])
end
